<?php
$url="http://my-dyndns.dyndns.com:8888/x.html";

$cache_file="/tmp/cached.xml";

$cache_time=filemtime($cache_file);
$offset=time()-$cache_time;

header('Content-type: text/xml');

if($offset>7) {
  exec("lynx -connect_timeout=20 --dump {$url} | sed 's/^\ *//' | grep -v ^\$ | grep -v google | grep -v References",$lines);
}
$line_parts=array('time','lat','lng','fix1','fix2','alt','speed','heading','pdop','hdop','vdop','hdr');

$pos=0;
$sats=array();

if(isset($lines) && !empty($lines)) {
  foreach ($lines as $line) {
    if($pos<count($line_parts)) {
      if($pos==0 || $pos==3 || $pos==4 ) {
        ${$line_parts[$pos]}=$line;
      } else {
        ${$line_parts[$pos]}=preg_replace('/.*=/','',$line);
      }
      $pos++;
    } else {
      array_push($sats,$line);
    }
  }
  $lock=$fix1 . ", " . $fix2;
  $now=date("D M j Y");
  $now.="&lt;br /&gt;";
  $now.=date("G:i:s T");
  $real=1;
} else {
  $real=0;
}
if($lat == '0.000000') {
  $real=0;
}

$output="";
if ( isset($real) && $real ) {
  $speed=sprintf("%0.1f",$speed);

  $output2=$output.="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<markers>\n";
  $output.=sprintf("  <marker name=\"Linuxkidd's GPS Tracking\" lat=\"%s\" lng=\"%s\" time=\"%s\" speed=\"%s\" heading=\"%d\" lock=\"%s\" altitude=\"%s\" pdop=\"%s\" hdop=\"%s\" vdop=\"%s\">\n",$lat,$lng,$now,$speed,$heading,$lock,$alt,$pdop,$hdop,$vdop);
  $output2.=sprintf("  <marker name=\"KR1\" lat=\"%s\" lng=\"%s\" time=\"&lt;b&gt;Cached:&lt;/b&gt; %s\" speed=\"%s\" heading=\"%d\" lock=\"%s\" altitude=\"%s\" pdop=\"%s\" hdop=\"%s\" vdop=\"%s\">\n",$lat,$lng,$now,$speed,$heading,$lock,$alt,$pdop,$hdop,$vdop);

  foreach($sats as $sat) {
    $sat_parts=split(" ",$sat);
    while(count($sat_parts)<5) {
      array_push($sat_parts,"");
    }
    $output.=sprintf("    <sat sn=\"%02d\" el=\"%02d\" azm=\"%03d\" sg=\"%02d\" u=\"%s\"/>\n",$sat_parts[0],$sat_parts[1],$sat_parts[2],$sat_parts[3],$sat_parts[4]);
    $output2.=sprintf("    <sat sn=\"%02d\" el=\"%02d\" azm=\"%03d\" sg=\"%02d\" u=\"%s\"/>\n",$sat_parts[0],$sat_parts[1],$sat_parts[2],$sat_parts[3],$sat_parts[4]);
  }
  $output.="  </marker>\n</markers>";
  $output2.="  </marker>\n</markers>";

  if ($file=fopen("tmp/cached.xml","w")) {
    fwrite($file,$output2);
    fclose($file);
  }
  print $output;
} else {
  if($offset>7) {
    foreach ( file($cache_file) as $lines ) {
      print $lines . "\n";
    }
  } else {
    foreach ( file($cache_file) as $lines ) {
      print preg_replace('/Cached:/','',$lines) . "\n";
    }
  }
}
